/*
 * Functions.java
 *
 * Created on 14. duben 2007, 11:08
 */

package link;


/**
 * Support class, don't call any of this methods directly.
 * @author Honza
 */
public class Functions {
    
    public static java.util.HashMap<String,String> convertQuerystringToArray(String string, String sep, String eq, String altSep) {
        string = string.replaceAll(altSep,sep);
        String[] parts = string.split(sep);
        java.util.HashMap<String,String> ra = new java.util.HashMap<String,String>();
        for (String v : parts) {
            String[] temp = v.split(eq);
            try {
                ra.put(temp[0],temp[1]);
            } catch (java.lang.ArrayIndexOutOfBoundsException e) {
                ra.put(temp[0],"");
            }
        }
        return ra;
    }
    
    public static String convertArrayToQuerystring(java.util.HashMap<String,String> params) {
        return convertArrayToQuerystring(params,"&");
    }
    
    public static String convertArrayToQuerystring(java.util.HashMap<String,String> params, String amp) {
        StringBuffer sb = new StringBuffer();
        java.util.Iterator<String> it = params.keySet().iterator();
        boolean fst = true;
        while (it.hasNext()) {
            if (fst) fst = false;
            else sb.append(amp);
            String key = it.next();
            sb.append(key+"="+params.get(key));
        }
        return sb.toString();
    }
    
    public static boolean compare(float a, String op, float b) {
        
        if (op.equals("lte")) return a<=b;
        if (op.equals("gte")) return a>=b;
        if (op.equals("lt")) return a<b;
        if (op.equals("gt")) return a>b;
        if (op.equals("eq")) return a==b;
        if (op.equals("neq")) return a!=b;

        return true;
    }
    
    public static boolean compare(String a, String op, String b) {
        
        if (op.equals("eq")) return a.equals(b);
        if (op.equals("neq")) return !a.equals(b);

        return true;
    }
    
    public static boolean validateType(String value, String type) {
        if (type.equals("int")) {
            try {
                int temp = Integer.parseInt(value);
                return true;
            } catch (NumberFormatException ex) {
                return false;
            }
        }
        if (type.equals("float")) {
            try {
                float temp = Float.parseFloat(value);
                return true;
            } catch (NumberFormatException ex) {
                return false;
            }
        }
        return true;
    }
    
    public static boolean constraint(String value, org.dom4j.Element cons) {
        
        for (java.util.Iterator<org.dom4j.Element> i = cons.elementIterator(); i.hasNext(); ) {
            org.dom4j.Element e = i.next();
            if (e.getName().equals("match")) {
                if (!value.matches(e.getTextTrim())) return false;
            } else if (e.getName().equals("compare")) {
                
                String temp = cons.elementTextTrim("value");
                if (temp!=null) {
                    try {
                        if (!Functions.compare(Float.parseFloat(value),e.getTextTrim(),Float.parseFloat(temp))) return false;
                    } catch (NumberFormatException ex) {
                        if (!Functions.compare(value,e.getTextTrim(),temp)) return false;
                    }
                }
               
            } else if (e.getName().equals("type")) {
                if (!Functions.validateType(value,e.getTextTrim())) return false;
            }
        }
        
        return true;
        
    }
    
    public static String getSeparator(org.dom4j.Element xml) {
        String att = xml.attributeValue("after");
        if (att==null || att.equals("")) return "/";
        return att;
    }
    public static String getSeparator() {
        return "/";
    }
    
    public static java.util.HashMap getSortedMap(java.util.HashMap hmap) {
        java.util.HashMap map = new java.util.LinkedHashMap();
        java.util.List mapKeys = new java.util.ArrayList(hmap.keySet());
        java.util.List mapValues = new java.util.ArrayList(hmap.values());
        hmap.clear();
        java.util.TreeSet sortedSet = new java.util.TreeSet(mapKeys);
        Object[] sortedArray = sortedSet.toArray();
        int size = sortedArray.length;
        
        for (int i=0; i<size; i++) {
            
            map.put(sortedArray[i], mapValues.get(mapKeys.indexOf(sortedArray[i])));
            
        }
        return map;
    }

    
    public static String prepareParamsForCache(java.util.HashMap params) {
        params = Functions.getSortedMap(params);
        return Functions.convertArrayToQuerystring(params);
    }
    
    public static java.util.HashMap<String,String> cache2params(String cache) {
        return Functions.convertQuerystringToArray(cache);
    }
    
    public static String getTablesPrefix(org.dom4j.Element conf) {
        java.util.List<org.dom4j.Element> temp = conf.elements("tablesprefix");
        if (temp.isEmpty()) return "link_";
        return temp.get(0).getTextTrim();
    }
    
    public static String removeSlash(String path) {
        String[] parts = path.split("\\?");
        parts[0] = parts[0].replaceFirst("/$","");
        try {
            parts[0] += "?"+parts[1];
        } catch (ArrayIndexOutOfBoundsException e) {
            ;
        }
        return parts[0];
    }
    
    public static String prepareforOutput(String path, org.dom4j.Element lConf) {
        try {
            if (lConf.element("removetrailingslash").getTextTrim().equals("1")) path = Functions.removeSlash(path);
        } catch (NullPointerException ex) {;}
        try {
            String prefix = lConf.element("urlprefix").getTextTrim();
            if (prefix!=null) path = prefix+path;
        } catch (NullPointerException ex) {;}
        try {
            String suffix = lConf.element("urlsuffix").getTextTrim();
            if (suffix!=null) path = path+suffix;
        } catch (NullPointerException ex) {;}
        return path;
    }
    
    public static boolean pageNotFound(org.dom4j.Element lConf, javax.servlet.http.HttpServletResponse response) {
        lConf = lConf.element("pagenotfound");
        if (lConf==null) return false;
        
        String behavior = lConf.elementTextTrim("behavior");
        String type = lConf.element("behavior").attributeValue("type");
        
        int code;
        try {
            code = Integer.parseInt(lConf.elementTextTrim("status"));
        } catch (NumberFormatException ex) {
            code = 404;
        }
        
        String res = "";
        
        if (type.equals("message")) res = behavior;
        else if (type.equals("page")) {
            try {
                java.io.FileReader fr = new java.io.FileReader(behavior);
                java.io.BufferedReader bfr = new java.io.BufferedReader(fr);
                String line;
                StringBuffer file = new StringBuffer();
                while ((line = bfr.readLine()) != null) {
                    file.append(line);
                }
                res = file.toString();
            } catch (java.io.FileNotFoundException ex) {
                res = "";
            } catch (java.io.IOException ex) {
                res = "";
            } 
        }
        else if (type.equals("redirect")) {
            try {
                response.sendError(code);
                response.sendRedirect(behavior);
                return true;
            } catch (java.io.IOException ex) {
                return false;
            }
        }
        try {
            response.sendError(code);
            response.getWriter().print(res);
            response.getWriter().flush();
            return true;
        } catch (java.io.IOException ex) {
            return false;
        }
    }
    
    public static java.util.HashMap<String,Boolean> getCoolParams(org.dom4j.Element lConf) {
        java.util.List<org.dom4j.Node> pars = lConf.selectNodes("//parameter");
        java.util.HashMap<String,Boolean> ret = new java.util.HashMap<String,Boolean>();
        for (org.dom4j.Node p : pars) {
            ret.put(((org.dom4j.Element)p).getTextTrim(),true);
        }
        org.dom4j.Element pagepath = lConf.element("pagepath");
        if (pagepath!=null) {
            String id = pagepath.elementTextTrim("id");
            if (id!=null) ret.put(id,true);
            String saveto = pagepath.elementTextTrim("saveto");
            if (saveto!=null) ret.put(saveto,true);
        }
        return ret;
    }
    
    public static java.util.HashMap<String,String> array_intersect_key(java.util.HashMap<String,String> arr1, java.util.HashMap<String,Boolean> arr2) {
        java.util.HashMap<String,String> res = new java.util.HashMap<String,String>();
        java.util.Set<String> ks = arr1.keySet();
        for (String key : ks) {
            if (arr2.containsKey(key)) res.put(key,arr1.get(key));
        }
        return res;
    }
    
    public static java.util.HashMap<String,String> array_diff_key(java.util.HashMap<String,String> arr1, java.util.HashMap<String,String> arr2) {
        java.util.HashMap<String,String> res = new java.util.HashMap<String,String>();
        java.util.Set<String> ks = arr1.keySet();
        for (String key : ks) {
            if (!arr2.containsKey(key)) res.put(key,arr1.get(key));
        }
        return res;
    }
    
    public static String utf2ascii(String s) {
        return java.text.Normalizer.normalize(s, java.text.Normalizer.Form.NFD).replaceAll("[^\\p{ASCII}]","");
    }
    
    public static String URLize(String text) {
        text = Functions.replaceUmlauts(text);
        text = Functions.utf2ascii(text);
        text = text.replaceAll("'","");
        text = text.replaceAll("\\W+","-");
        text = text.trim();
        text = text.replaceAll("^-+","");
        text = text.replaceAll("-+$","");
        text = text.toLowerCase();
        return text;
    }
    
    public static String strtr(String string, java.util.HashMap<String,String> replace) {
        for (String key : replace.keySet()) {
            string = string.replaceAll(key,replace.get(key));
        }
        return string;
    }
    
    public static String replaceUmlauts(String string) {
        java.util.HashMap<String,String> umlauts = new java.util.HashMap<String,String>();
        umlauts.put("","ae");
        umlauts.put("","oe");
        umlauts.put("","ue");
        umlauts.put("","ss");
        umlauts.put("","ae");
        umlauts.put("","oe");
        umlauts.put("","ue");
        return Functions.strtr(string,umlauts);
    }
    
    public static Object user_func(org.dom4j.Element lConf, String value) {
        org.dom4j.Element userfunc = lConf.element("userfunc");
        if (userfunc!=null) {
            String[] uf = userfunc.getTextTrim().split("->");
            try {
                Class cls = Class.forName(uf[0]);
                Class partypes[] = new Class[2];
                partypes[0] = org.dom4j.Element.class;
                partypes[1] = String.class;
                java.lang.reflect.Method m = cls.getMethod(uf[1],partypes);
                return m.invoke(lConf,value);
            } catch (Exception ex) {
                return null;
            }
        }
        return null;
    }
    
    public static Object user_func(org.dom4j.Element lConf, java.util.Map<String,String> value) {
        org.dom4j.Element userfunc = lConf.element("userfunc");
        if (userfunc!=null) {
            String[] uf = userfunc.getTextTrim().split("->");
            try {
                Class cls = Class.forName(uf[0]);
                Class partypes[] = new Class[2];
                partypes[0] = org.dom4j.Element.class;
                partypes[1] = java.util.Map.class;
                java.lang.reflect.Method m = cls.getMethod(uf[1],partypes);
                return m.invoke(lConf,value);
            } catch (Exception ex) {
                return null;
            }
        }
        return null;
    }
    
    public static boolean redirect(String url, javax.servlet.http.HttpServletResponse response) throws java.io.IOException {
        try {
            response.sendRedirect(url);
            return true;
        } catch (NullPointerException ex) {
            System.err.println("Redirecting to "+url+" didn't suceed.");
            return false;
        }
    }
    
    public static String lookindb(String sql, String param, org.dom4j.Element conf) {
        try {
            sql = sql.replaceAll("\\$1",param);
            java.sql.Statement db = DB.getInstance();
            java.sql.ResultSet res = db.executeQuery(sql);
            if (!res.last()) {
                return param;
            }
            String val = res.getString(1);
            try {
                int k = 2;
                while (val==null || val.equals("")) {
                    val = res.getString(k);
                    ++k;
                }
            } catch (java.sql.SQLException ex) {
                ;
            }
            if (conf.elementTextTrim("urlize")!=null && conf.elementTextTrim("urlize").equals("1")) {
                return URLize(val);
            }
            return val;
        } catch (java.sql.SQLException ex) {
            return param;
        }
    }
    
    public static String implode(String sep, java.util.List<String> list) {
        boolean fst = true;
        StringBuffer buf = new StringBuffer();
        for (String s : list) {
            if (!fst) buf.append(sep);
            else fst = false;
            buf.append(s);
        }
        return buf.toString();
    }
    
    // overloads
    public static java.util.HashMap convertQuerystringToArray(String string) {
        return Functions.convertQuerystringToArray(string,"&","=","&amp;");
    }
    public static java.util.HashMap convertQuerystringToArray(String string, String sep) {
        return Functions.convertQuerystringToArray(string,sep,"=","&amp;");
    }
    public static java.util.HashMap convertQuerystringToArray(String string, String sep, String eq) {
        return Functions.convertQuerystringToArray(string,sep,eq,"&amp;");
    }
}