/*
 * Translate.java
 *
 * Created on 17. duben 2007, 10:59
 *
 */

package link;

import org.dom4j.Element;

/**
 * Main translating class of the URI Transformer project.
 * @author Honza
 */
public class Translate {
    
    private static Translate instance = null;
    
    private static org.dom4j.Document conf;
    
    private static javax.servlet.http.HttpServletResponse response;
    
    private java.util.HashMap<String,String> parameters = new java.util.HashMap<String,String>();
    
    private static java.util.HashMap<String,Boolean> coolParamsKeys = null;
    
    
    /**
     * Return an instance of this class. Do not instantiate using new, as it would cause that XML file would be parsed everytime.
     * @param xmlconffile Path to the conf file
     * @param resp Response object
     * @throws org.dom4j.DocumentException If the conf file isn't found
     * @return Translate instance
     */
    public static Translate getInstance(String xmlconffile, javax.servlet.http.HttpServletResponse resp) throws org.dom4j.DocumentException {
        if (instance==null) {
            instance = new Translate(xmlconffile,resp);
        }
        return instance;
    }
    
    /**
     * Return an instance of this class. Do not instantiate using new, as it would cause that XML file would be parsed everytime.
     * @param resp Response object
     * @throws org.dom4j.DocumentException If the conf file isn't found
     * @return Translate instance
     */
    public static Translate getInstance(javax.servlet.http.HttpServletResponse resp) throws org.dom4j.DocumentException {
        return getInstance("CoolUriConf.xml",response);
    }
    
    /**
     * Creates a new instance of Translate
     * @param xmlconffile 
     * @param resp 
     * @throws org.dom4j.DocumentException 
     */
    private Translate(String xmlconffile, javax.servlet.http.HttpServletResponse resp) throws org.dom4j.DocumentException {
        org.dom4j.io.SAXReader reader = new org.dom4j.io.SAXReader();
        conf = reader.read(xmlconffile);
        response = resp;
    }
    
    /**
     * Use this method when a URI is automatically retrieved from server's variables.
     * @param request HTTP request
     * @throws java.io.IOException if something goes wrong
     * @throws java.sql.SQLException if something goes wrong
     * @return Map of parametrs
     */
    public java.util.HashMap cool2params(javax.servlet.http.HttpServletRequest request) throws java.io.IOException, java.sql.SQLException { 
        org.dom4j.Element lConf = conf.getRootElement();
        String uri = "";
        org.dom4j.Element ue = lConf.element("uri");
        if (ue!=null) {
            java.util.List<org.dom4j.Element> parts = ue.elements("part");
            for (org.dom4j.Element part : parts) {
                String var = part.getTextTrim();
                if (var.equals("QUERY_STRING")) {
                    uri += request.getQueryString();
                } else if (var.equals("REMOTE_HOST")) {
                    uri += request.getRemoteHost();
                } else if (var.equals("SCRIPT_NAME")) {
                    uri += request.getServletPath();
                } else if (var.equals("SERVER_NAME")) {
                    uri += request.getServerName();
                } else if (var.startsWith("HTTP_")) {
                    uri += request.getHeader(var);
                }
            }
        }
        return cool2params(uri);
    }
    
    /**
     * Use this method when a URI is automatically retrieved from server's variables.
     * @param uri URI
     * @return Map of parametrs
     * @throws java.io.IOException if something goes wrong
     * @throws java.sql.SQLException if something goes wrong
     */
    public java.util.HashMap cool2params(String uri) throws java.io.IOException, java.sql.SQLException {
                
        org.dom4j.Element lConf = conf.getRootElement();
        
        String cooluris = lConf.elementTextTrim("cooluris");
        
        String originaluri = uri;
        
        java.util.HashMap cachedparams = null;
        
        if (cooluris!=null && cooluris.equals("1")) {
            
            // let's remove uninteresting parts (those are not even cached)
            org.dom4j.Element removeparts = lConf.element("removeparts");
            if (removeparts!=null) {
                java.util.List<org.dom4j.Element> parts = removeparts.elements("part");
                for (org.dom4j.Element part : parts) {
                    String regexp = part.attributeValue("regexp");
                    if (regexp!=null && regexp.equals("1")) {
                        uri = uri.replaceAll(part.getTextTrim(),"");
                    } else {
                        uri = uri.replace(part.getTextTrim(),"");
                    }
                }
                
                if (removeparts.attributeValue("redirect")!=null && removeparts.attributeValue("redirect").equals("1")) {
                    if (!uri.equals(originaluri)) {
                        Functions.redirect(Functions.prepareforOutput(uri,lConf),response); return null;
                    }
                }
            }
            
            // now we remove opening slash
            uri = uri.replaceFirst("^/*","");
            
            if (uri.equals("")) return null;
            
            org.dom4j.Element cache = lConf.element("cache");
            if (cache!=null && cache.elementTextTrim("usecache")!=null && cache.elementTextTrim("usecache").equals("1")) {
                String tp = Functions.getTablesPrefix(cache);
                java.sql.Statement db = DB.getInstance();
                
                String[] tempuri = uri.split("\\?");
                String xuri = tempuri[0];
                if (tempuri[0].matches(".*/$"))
                    tempuri[0] = tempuri[0].substring(0,tempuri[0].length()-1);
                else {
                    tempuri[0] += "/";
                }
                
                String tempurix;
                if (cache.elementTextTrim("cacheparams")!=null && cache.elementTextTrim("cacheparams").equals("1")) {
                    try {
                        tempurix = tempuri[0]+"?"+tempuri[1];
                    } catch (ArrayIndexOutOfBoundsException ex) {
                        tempurix = tempuri[0];
                    }
                    xuri = uri;
                } else {
                    tempurix = tempuri[0];
                }
                
                java.sql.ResultSet q = db.executeQuery("SELECT * FROM "+tp+"cache WHERE url='"+xuri+"' OR url='"+tempurix+"'");
                if (q.last()) {
                    if (!q.getString("url").equals(xuri)) {  // we've got our $tempuri, not $url -> let's redirect
                        String red = q.getString("url");
                        try {
                            red += "?"+tempuri[1];
                        } catch (ArrayIndexOutOfBoundsException ex) {;}
                        Functions.redirect(Functions.prepareforOutput(red,lConf),response);
                        return null;
                    } else {
                        cachedparams = Functions.cache2params(q.getString("params"));
                    }
                } else {
                    String vf = "";
                    try {
                        String olvf = cache.element("cool2params").elementTextTrim("oldlinksvalidfor");
                        int valid = Integer.parseInt(olvf);
                        vf = " AND DATEDIFF(NOW(),"+tp+"oldlinks.tstamp)<"+valid;
                    } catch (NullPointerException ex) {;
                    } catch (NumberFormatException ex) {;
                    }
                    q = db.executeQuery("SELECT "+tp+"cache.url AS oldlink FROM "+tp+"oldlinks LEFT JOIN "+tp+"cache ON "+tp+"oldlinks.link_id="+tp+"cache.id WHERE ("+tp+"oldlinks.url='"+xuri+"' OR "+tp+"oldlinks.url='"+tempurix+"')"+vf);
                    if (q.last()) {
                        try {
                            Functions.redirect(Functions.prepareforOutput(q.getString("oldlink")+"?"+tempuri[1],lConf),response); return null;
                        } catch (ArrayIndexOutOfBoundsException ex) {
                            Functions.redirect(Functions.prepareforOutput(q.getString("oldlink"),lConf),response); return null;
                        }
                    } else if (cache.element("cool2params")==null || cache.element("cool2params").elementTextTrim("translateifnotfound")==null || !cache.element("cool2params").elementTextTrim("translateifnotfound").equals("1")) {
                        Functions.pageNotFound(cache,response);
                    }
                } 
            } // end cache
            
            //now we have a uri which will be parsed (without unwanted stuff)
            java.util.HashMap<String,String> finaluriparts = new java.util.HashMap<String,String>();
            if (!uri.equals("") && (cachedparams==null || cachedparams.size()==0)) {
                uri = uri.replaceFirst("/*$","");
                
                String coolpart;
                String dirtypart = null;
                
                String[] temp = uri.split("\\?");
                coolpart = temp[0];
                try {
                    dirtypart = temp[1];
                } catch (ArrayIndexOutOfBoundsException ex) {
                    ;
                }
                
                if (!coolpart.equals("")) {
                    String pathsep = "";
                    org.dom4j.Element pathseparators = lConf.element("pathseparators");
                    if (pathseparators!=null) {
                        java.util.List<org.dom4j.Element> separators = pathseparators.elements("separator");
                        for (org.dom4j.Element sep : separators) {
                            pathsep += sep.getTextTrim();
                        }
                    } else {
                        pathsep = "/";
                    }
                    
                    String[] x = coolpart.split("["+pathsep+"]");
                    java.util.List<String> coolparts = new java.util.LinkedList<String>();
                    for (int i = 0;i<x.length;i++) coolparts.add(x[i]);
                    
                    // at first we go through the predefined parts
                    org.dom4j.Element predefinedparts = lConf.element("predefinedparts");
                    if (predefinedparts!=null) {
                        java.util.List<org.dom4j.Element> parts = predefinedparts.elements("part");
                        for (org.dom4j.Element part : parts) {
                            java.util.List<String> tempcoolparts = new java.util.LinkedList<String>();
                            tempcoolparts.addAll(coolparts);
                            for (String cp : tempcoolparts) {
                                
                                String par = null;
                                if (part.attributeValue("regexp")!=null && part.attributeValue("regexp").equals("1")) {
                                    if (cp.matches(part.attributeValue("key"))) {
                                        par = cp.replaceFirst(part.attributeValue("key"),part.elementTextTrim("value"));
                                    } else if (part.attributeValue("key").equals(cp)) {
                                        par = part.elementTextTrim("value");
                                    }
                                }
                                
                                // we found a match in predef parts
                                if (par!=null) {
                                    // first we find out if it's possible to find anything in the db
                                    boolean cantranslate = true;
                                    if (part.element("lookindb")!=null && part.element("lookindb").element("translatefromif")!=null) {
                                        cantranslate = Functions.constraint(par,part.element("lookindb").element("translatefromif"));
                                    }
                                    
                                    // we don't look into db for result
                                    if (part.element("lookindb")==null || !cantranslate) {
                                        finaluriparts.put(part.elementTextTrim("parameter"),par);
                                      // we do
                                    } else {
                                        java.sql.Statement db = DB.getInstance();
                                        java.sql.ResultSet res = db.executeQuery(cp.replaceFirst("^"+part.attributeValue("key")+"$",part.element("lookindb").elementTextTrim("from")));
                                        // we return value only if we found something
                                        if (res.last()) {
                                            finaluriparts.put(part.elementTextTrim("parameter"),res.getString(1));
                                        }
                                    }
                                    
                                    // we found a match, so we throw out this cool part, no matter if we got a result
                                    coolparts.remove(cp);
                                }
                                
                            }
                        }
                    } // end predefined parts
                    
                    org.dom4j.Element valuemaps = lConf.element("valuemaps");
                    if (valuemaps!=null) {
                        java.util.List<org.dom4j.Element> tempvms = valuemaps.elements("valuemap");
                        for (org.dom4j.Element vm : tempvms) {
                            java.util.List<org.dom4j.Element> values = vm.elements("value");
                            for (org.dom4j.Element val : values) {
                                if (coolparts.contains(val.attributeValue("key"))) {
                                    finaluriparts.put(vm.elementTextTrim("parameter"),val.getTextTrim());
                                    coolparts.remove(val.attributeValue("key"));
                                    break;
                                }
                            }
                        }
                    } // end valuemaps
                    
                    java.util.HashMap<String,Boolean> nottranslated = new java.util.HashMap<String,Boolean>();
                    // something's still left
                    if (coolparts.size()>0 && lConf.element("uriparts")!=null) {
                        
                        String lastonthepath = null;
                        
                        java.util.List<org.dom4j.Element> parts = lConf.element("uriparts").elements("part");
                        
                        for (int i=0,j=0; i<coolparts.size() && j<parts.size(); i++,j++) {
                            if (coolparts.get(i).equals("")) continue; // we don't have a item on this key, shouldn't happen
                            
                            // if a part is not required and next (static) part matches, we skip to it
                            // i.e. category.example.com vs. example.com (in this case "example" would be 
                            // considered for a category otherwise)
                            if (parts.get(j).attributeValue("notrequired")!=null && parts.get(j).attributeValue("notrequired").equals("1")
                             && parts.get(j+1)!=null && parts.get(j+1).attributeValue("static")!=null 
                             && parts.get(j+1).attributeValue("static").equals("1") && parts.get(j+1).elementTextTrim("value").equals(coolparts.get(i))
                            ) {
                                ++j; // we skip to next key in conf 
                            }
                            
                            // if current part is static and matches, we move on
                            // if is static, but doesn't match, we move on
                            if (parts.get(j).attributeValue("static")!=null && parts.get(j).attributeValue("static").equals("1")) {
                                if (parts.get(j).elementTextTrim("value").equals(coolparts.get(i))) {
                                    continue;
                                } else {
                                    ++j;
                                }
                            }
                            
                            // this should be a dynamic param
                            if (parts.get(j).element("parameter")!=null) {
                                // we preset the variable, if may change after
                                finaluriparts.put(parts.get(j).elementTextTrim("parameter"),coolparts.get(i));
                                
                                // first we find out if it's possible to find anything in the db
                                boolean cantranslate = true;
                                if (parts.get(j).element("lookindb")!=null && parts.get(j).element("lookindb").element("translatefromif")!=null) {
                                    cantranslate = Functions.constraint(coolparts.get(i),parts.get(j).element("lookindb").element("translatefromif"));
                                }
                                
                                // a feature from PHP isn't implemented here, because of a lack of preg_match_all function synonym (or I don't know abou it)
                                
                                if (parts.get(j).element("lookindb")!=null && cantranslate && parts.get(j).element("lookindb").element("from")!=null) {
                                    String sql = parts.get(j).element("lookindb").elementTextTrim("from");
                                    sql = sql.replaceFirst("\\$1",coolparts.get(i));
                                    
                                    java.sql.Statement db = DB.getInstance();
                                    java.sql.ResultSet res = db.executeQuery(sql);
                                    
                                    if (res.last()) {
                                        finaluriparts.put(parts.get(j).elementTextTrim("parameter"), res.getString(1));
                                    } else {
                                        nottranslated.put(parts.get(j).elementTextTrim("parameter"), true);
                                    }
                                    
                                } else if (lConf.element("pagepath")!=null && parts.get(j).attributeValue("pagepath")!=null && parts.get(j).attributeValue("pagepath").equals("1")) {
                                    org.dom4j.Element pagepath = lConf.element("pagepath");
                                    // this param is part of the pagepath, let's try that
                                    if (lastonthepath==null || finaluriparts.get(lastonthepath)!=null) {
                                        java.sql.Statement db = DB.getInstance();
                                        String sql = "SELECT "+pagepath.elementTextTrim("id")+" FROM "+pagepath.elementTextTrim("table")+
                                                " WHERE "+pagepath.elementTextTrim("alias")+"='"+coolparts.get(i)+"'";
                                        if (lastonthepath==null) sql += " AND "+pagepath.element("start").elementTextTrim("param")+"="+pagepath.element("start").elementTextTrim("value");
                                        else sql += " AND "+pagepath.elementTextTrim("connection")+"="+finaluriparts.get(lastonthepath);
                                        try {
                                            java.sql.ResultSet res = db.executeQuery(sql);
                                            if (res.last()) {
                                            finaluriparts.put(parts.get(j).elementTextTrim("parameter"),res.getString(1));
                                            } else {
                                                nottranslated.put(parts.get(j).elementTextTrim("parameter"),true);
                                            }
                                        } catch (java.sql.SQLException ex) {
                                            nottranslated.put(parts.get(j).elementTextTrim("parameter"),true);
                                        }
                                        lastonthepath = parts.get(j).elementTextTrim("parameter");
                                    } else {
                                        nottranslated.put(parts.get(j).elementTextTrim("parameter"),true);
                                    }
                                }
                            }
                            
                        }
                        
                    } // end uriparts
                    
                }
                // Cool part done, let's add dirty part
                if (dirtypart!=null && !dirtypart.equals("")) {
                    finaluriparts.putAll(Functions.convertQuerystringToArray(dirtypart));
                }

                // Now we'll compose our return pagepath to one variable (i.e. id could be one of cid,sid,lid,tid)
                org.dom4j.Element saveto = null;
                if (lConf.element("pagepath")!=null) {
                    saveto = lConf.element("pagepath").element("saveto");
                    if (saveto!=null) {

                        // first we'll set a default value (if not set already)
                        if (finaluriparts.get(saveto.getTextTrim())==null)
                            finaluriparts.put(saveto.getTextTrim(),lConf.element("pagepath").elementTextTrim("default"));

                        // let's modify param constraints array a bit:
                        java.util.HashMap<String,org.dom4j.Element> paramconstraints = new java.util.HashMap<String,org.dom4j.Element>();
                        try {
                            java.util.List<org.dom4j.Element> pcs = lConf.element("uriparts").element("paramconstraints").elements("paramconstraint");
                            for (org.dom4j.Element pc : pcs) {
                                paramconstraints.put(pc.attributeValue("param"),pc);
                            }
                        } catch (NullPointerException ex) {
                            ;
                        }

                        boolean rqok = true;

                        // first we'll check if a required param is OK
                        org.dom4j.Element required = lConf.element("pagepath").element("required");
                        if (required!=null) {
                            java.util.List<org.dom4j.Element> ps = required.elements("param");
                            org.dom4j.Element allcons = lConf.element("pagepath").element("allconstraints");
                            for (org.dom4j.Element p : ps) {
                                String pp = p.getTextTrim();
                                if (finaluriparts.get(pp)==null)
                                    rqok = false;
                                else if (finaluriparts.get(pp)!=null && paramconstraints.get(pp)!=null && !Functions.constraint(finaluriparts.get(pp),paramconstraints.get(pp)))
                                    rqok = false;
                                else if (allcons!=null && !Functions.constraint(finaluriparts.get(pp),allcons))
                                    rqok = false;
                            }
                        }

                        // now we'll go through all params, check if they're ok and eventually set the final value
                        if (rqok) { // only if required is OK
                            java.util.LinkedList<org.dom4j.Element> px = new java.util.LinkedList<org.dom4j.Element>();
                            px.addAll(lConf.element("uriparts").elements("part"));

                            java.util.Collections.reverse(px);
                            for (org.dom4j.Element p : px) {
                                if (p.attributeValue("pagepath")==null || !p.attributeValue("pagepath").equals("1")) continue;
                                String pp = p.elementTextTrim("parameter");
                                if (finaluriparts.get(pp)!=null) {
                                    if (paramconstraints.get(pp)!=null && !Functions.constraint(finaluriparts.get(pp),paramconstraints.get(p))) continue;
                                    
                                    if (lConf.element("pagepath")!=null && lConf.element("pagepath").element("allparamconstraints")!=null
                                        && !Functions.constraint(finaluriparts.get(pp),lConf.element("pagepath").element("allparamconstraints"))) continue;

                                    if (lConf.element("pagepath")!=null) {
                                        finaluriparts.put(lConf.element("pagepath").elementTextTrim("saveto"),finaluriparts.get(pp));
                                        break;
                                    }
                                }
                            }
                        }
                            
                    }
                    
                    
                } // end coolpart translation
                
            } // end !empty($uri) && empty($cachedparams)
            
            if (cachedparams==null || cachedparams.isEmpty())
                this.parameters = finaluriparts;
            else
                this.parameters = cachedparams;
            return this.parameters;
        } // end cooluris = 1
        
        return null;
    }
    
    /**
     * Translates parameters to a CoolURI
     * @param params Map of params
     * @throws java.io.IOException if something goes wrong
     * @throws java.sql.SQLException if something goes wrong
     * @return CoolURI
     */
    public String params2cool(java.util.HashMap<String,String> params) throws java.io.IOException, java.sql.SQLException {
        return params2cool(params,"",true,false,false);
    }
    
    /**
     * Translates parameters to a CoolURI
     * @param params Map of params
     * @param file If CoolURIs are disabled this file will be linked in a DirtyURI
     * @param entityampersand true - will separate values in dirty part with entity ampersand
     * @param dontconvert return a dirty URI
     * @param forceUpdate force link update (only if cache is enabled)
     * @throws java.io.IOException if something goes wrong
     * @throws java.sql.SQLException if something goes wrong
     * @return CoolURI
     */
    public String params2cool(java.util.HashMap<String,String> params, String file, boolean entityampersand, boolean dontconvert, boolean forceUpdate) throws java.io.IOException, java.sql.SQLException {
        org.dom4j.Element lConf = conf.getRootElement();

        String cooluris = lConf.elementTextTrim("cooluris");
        if (cooluris!=null && cooluris.equals("1") && !dontconvert) {
            
            int updatecacheid = 0;
            String cacheduri = null;
            
            // if cache is allowed, we'll look for an uri
            org.dom4j.Element cache = lConf.element("cache");
            if (cache!=null && cache.elementTextTrim("usecache")!=null && cache.elementTextTrim("usecache").equals("1")) {
                String tp = Functions.getTablesPrefix(cache);
                java.sql.Statement db = DB.getInstance();
                org.dom4j.Element params2cool = cache.element("params2cool");
                // cache is valid for only a sort period of time, after that time we need to do a recheck
                int checkfornew = 0;
                try {
                    checkfornew = (params2cool!=null && params2cool.elementTextTrim("checkforchangeevery")!=null)?Integer.parseInt(params2cool.elementTextTrim("checkforchangeevery")):0;
                } catch (NumberFormatException ex) {
                    ;
                }
                java.util.HashMap<String,String> originalparams = new java.util.HashMap<String,String>();
                originalparams.putAll(params); // clone params to originalparams
                
                // we don't cache params
                if (cache.elementTextTrim("cacheparams")==null || !cache.elementTextTrim("cacheparams").equals("1")) {
                    if (coolParamsKeys==null) coolParamsKeys = Functions.getCoolParams(lConf);
                    originalparams = Functions.array_intersect_key(originalparams,coolParamsKeys);
                }
                
                java.sql.ResultSet q = db.executeQuery("SELECT *, DATEDIFF(NOW(),tstamp) AS daydiff FROM "+tp+"cache WHERE params='"+Functions.prepareParamsForCache(originalparams)+"'");
                if (q.last()) {
                    int daydiff = q.getString("daydiff")==null?2147483647:q.getInt("daydiff");
                    if (daydiff>=checkfornew && !q.getBoolean("sticky") || forceUpdate) {
                        updatecacheid = q.getInt("id");
                        cacheduri = q.getString("url");
                    } else {
                        String qs = "";
                        if (cache.elementTextTrim("cacheparams")==null || !cache.elementTextTrim("cacheparams").equals("1")) {
                            java.util.HashMap<String,String> qsp = Functions.array_diff_key(params,originalparams);
                            if (!qsp.isEmpty()) {
                                qs = "?"+Functions.convertArrayToQuerystring(qsp);
                            }
                        }
                        return Functions.prepareforOutput(q.getString("url"),lConf)+qs;
                    }
                }
                
            } // end cache
            
            java.util.HashMap<String,String> originalparams = new java.util.HashMap<String,String>();
            originalparams.putAll(params); // clone params to originalparams
            java.util.HashMap<String,String> predefparts = new java.util.HashMap<String,String>();
            
            org.dom4j.Element predefinedparts = lConf.element("predefinedparts");
            if (predefinedparts!=null) {
                java.util.List<org.dom4j.Element> part = predefinedparts.elements("part");
                for (org.dom4j.Element ppart : part) {
                    String parameter = ppart.elementTextTrim("parameter");
                    if (params.get(parameter)!=null) {
                        Object uf = Functions.user_func(ppart,params.get(parameter));
                        if (uf!=null) {
                            predefparts.put(parameter,(String)uf);
                        } else {
                            String temp = null;
                            if (ppart.element("lookindb")!=null) {
                                temp = Functions.lookindb(ppart.element("lookindb").elementTextTrim("to"),params.get(parameter),ppart.element("lookindb"));
                            }
                            if (ppart.attributeValue("regexp")!=null && ppart.attributeValue("regexp").equals("1")) {
                                predefparts.put(parameter,ppart.attributeValue("key").replaceAll("\\([^)]+\\)",temp==null?params.get(parameter):temp));
                            } else {
                                predefparts.put(parameter,temp==null?params.get(parameter):temp);
                            }
                        }
                        params.remove(parameter);
                    }
                }
            } // end predefinedparts
            
            //valuemaps (iterate thru values in maps)
            if (lConf.element("valuemaps")!=null) {
               java.util.List<org.dom4j.Element> valuemaps = lConf.element("valuemaps").elements("valuemap");
               for (org.dom4j.Element vm : valuemaps) {
                   if (params.get(vm.elementText("parameter"))!=null) {
                       java.util.List<org.dom4j.Element> values = vm.elements("value");
                       for (org.dom4j.Element val : values) {
                           if (val.getTextTrim().equals(params.get(vm.elementText("parameter")))) {
                               predefparts.put(vm.elementText("parameter"),val.attributeValue("key"));
                               params.remove(vm.elementText("parameter"));
                           }
                       }
                   }
               }
            }
            
            // now the pagepath
            java.util.HashMap<String,String> translatedpagepath = new java.util.HashMap<String,String>();
            java.util.List<String> pagepath = new java.util.LinkedList<String>();
            
            org.dom4j.Element pagepathel = lConf.element("pagepath");
            if (pagepathel!=null && pagepathel.element("saveto")!=null && params.get(pagepathel.elementTextTrim("saveto"))!=null) {
                
                java.util.List<String> uf = (java.util.List<String>)Functions.user_func(pagepathel,originalparams);
                if (uf==null) {
                    String curid = params.get(pagepathel.elementTextTrim("saveto"));
                    boolean result = true;
                    String lastpid = null;
                    java.sql.Statement db = DB.getInstance();
                    int limit = 10;
                    
                    while (limit>0 && pagepathel.element("idconstraint")==null?result:(result && Functions.constraint(curid,pagepathel.element("idconstraint")))) {
                        --limit;
                        String sel;
                        if (pagepathel.elementTextTrim("alias")==null) {
                            sel = pagepathel.elementTextTrim("title");
                        } else {
                            sel = pagepathel.elementTextTrim("alias");
                        }
                        String sql = "SELECT "+pagepathel.elementTextTrim("connection")+","+sel+
                                " FROM "+pagepathel.elementTextTrim("table")+" WHERE "+pagepathel.elementTextTrim("id")+"="+
                                (lastpid==null?params.get(pagepathel.elementTextTrim("saveto")):lastpid);
                        if (pagepathel.elementTextTrim("additionalWhere")!=null) {
                            sql += " "+pagepathel.elementTextTrim("additionalWhere");
                        }
                        
                        try {
                            java.sql.ResultSet res = db.executeQuery(sql);
                            if (res.last()) {
                                if (pagepathel.elementTextTrim("alias")==null) {
                                    String val = res.getString(2);
                                    try {
                                        int k = 3;
                                        while (val==null || val.equals("")) {
                                            val = res.getString(k);
                                            ++k;
                                        }
                                    } catch (java.sql.SQLException ex) {
                                        ;
                                    }
                                    pagepath.add(Functions.URLize(val));
                                } else {
                                    pagepath.add(res.getString(2));
                                }
                                lastpid = res.getString(1);
                            } else {
                                throw new java.sql.SQLException();
                            }
                        } catch (java.sql.SQLException ex) {
                            result = false;
                            continue;
                        }
                    }
                } else {
                    pagepath = uf;
                }
                params.remove(pagepathel.elementTextTrim("saveto"));
                if (!pagepath.isEmpty()) java.util.Collections.reverse(pagepath);
            } // end pagepath
            
            org.dom4j.Element uriparts = lConf.element("uriparts");
            if (uriparts!=null) {
                int counter = 0;
                
                java.util.List<org.dom4j.Element> parts = uriparts.elements("part");
                for (org.dom4j.Element pp : parts) {
                    String uf = null;
                    if (params.get(pp.elementTextTrim("parameter"))!=null) {
                        uf = (String)Functions.user_func(pp,params.get(pp.elementTextTrim("parameter")));
                    }
                    if (uf!=null) {
                        translatedpagepath.put(pp.elementTextTrim("parameter"),uf);
                    } else if (pp.attributeValue("pagepath")!=null && pp.attributeValue("pagepath").equals("1") && pagepath.size()>counter) {
                        translatedpagepath.put(pp.elementTextTrim("parameter"),pagepath.get(counter));
                        //pagepath.remove(counter);
                        pagepath.set(counter,"");
                        ++counter;
                    } else if (params.get(pp.elementTextTrim("parameter"))!=null) {
                        String temp = params.get(pp.elementTextTrim("parameter"));
                        if (pp.element("lookindb")!=null) {
                            temp = Functions.lookindb(pp.element("lookindb").elementTextTrim("to"),temp,pp.element("lookindb"));
                        }
                        translatedpagepath.put(pp.elementTextTrim("parameter"),temp);
                    }
                }
            }
            for (int i=0,j=0;i<pagepath.size();i++,j++) {
                if (pagepath.get(i).equals("")) {
                    pagepath.remove(i);
                    --i;
                }
            }
            
            String path = "";
            java.util.HashMap<String,Boolean> paramsinorder = new java.util.HashMap<String,Boolean>();
            java.util.HashMap<String,String> statics = new java.util.HashMap<String,String>();
            org.dom4j.Element paramorder = lConf.element("paramorder");
            if (paramorder!=null) {
                java.util.List<org.dom4j.Element> pars = paramorder.elements("param");
                if (!pars.isEmpty()) {
                    if (lConf.element("uriparts")!=null) {
                        java.util.List<org.dom4j.Element> parts = lConf.element("uriparts").elements("part");
                        for (org.dom4j.Element part : parts) {
                            if (part.attributeValue("static")!=null && part.attributeValue("static").equals("1")) {
                                statics.put(part.elementTextTrim("value"),part.elementTextTrim("value"));
                            }
                        }
                    }
                }
                
                // we need list of separators
                java.util.HashMap<String,String> seps = new java.util.HashMap<String,String>();
                java.util.List<org.dom4j.Element> temp;
                if (lConf.element("predefinedparts")!=null) {
                    temp = lConf.element("predefinedparts").elements("part");
                    for (org.dom4j.Element part : temp) {
                        seps.put(part.elementTextTrim("parameter"),Functions.getSeparator(part));
                    }
                }
                if (lConf.element("valuemaps")!=null) {
                    temp = lConf.element("valuemaps").elements("valuemap");
                    for (org.dom4j.Element part : temp) {
                        seps.put(part.elementTextTrim("parameter"),Functions.getSeparator(part));
                    }
                }
                if (lConf.element("uriparts")!=null) {
                    temp = lConf.element("uriparts").elements("part");
                    for (org.dom4j.Element part : temp) {
                        if (part.attributeValue("static")!=null && part.attributeValue("static").equals("1"))
                            seps.put(part.elementTextTrim("value"),Functions.getSeparator(part));
                        else
                            seps.put(part.elementTextTrim("parameter"),Functions.getSeparator(part));
                    }
                }
                for (org.dom4j.Element par : pars) {
                    paramsinorder.put(par.getTextTrim(),true);
                    if (predefparts.get(par.getTextTrim())!=null) {
                        path += predefparts.get(par.getTextTrim())+seps.get(par.getTextTrim());
                    } else if (translatedpagepath.get(par.getTextTrim())!=null) {
                        path += translatedpagepath.get(par.getTextTrim())+seps.get(par.getTextTrim());
                    } else if (statics.get(par.getTextTrim())!=null) {
                        path += statics.get(par.getTextTrim())+seps.get(par.getTextTrim());
                    }
                }
            } // end paramorder
            
            String vm = "";
            org.dom4j.Element valuemaps = lConf.element("valuemaps");
            if (valuemaps!=null) {
                java.util.List<org.dom4j.Element> temp = valuemaps.elements("valuemap");
                for (org.dom4j.Element part : temp) {
                    if (predefparts.get(part.elementTextTrim("parameter"))!=null && paramsinorder.get(part.elementTextTrim("parameter"))==null) {
                        vm += predefparts.get(part.elementTextTrim("parameter"))+Functions.getSeparator(part);
                        predefparts.remove(part.elementTextTrim("parameter"));
                        params.remove(part.elementTextTrim("parameter"));
                    }
                }
            }
            
            String pp = "";
            org.dom4j.Element predefinedpartsel = lConf.element("predefinedparts");
            if (predefinedpartsel!=null) {
                java.util.List<org.dom4j.Element> temp = predefinedpartsel.elements("part");
                for (org.dom4j.Element part : temp) {
                    if (predefparts.get(part.elementTextTrim("parameter"))!=null && paramsinorder.get(part.elementTextTrim("parameter"))==null) {
                        pp += predefparts.get(part.elementTextTrim("parameter"))+Functions.getSeparator(part);
                        predefparts.remove(part.elementTextTrim("parameter"));
                        params.remove(part.elementTextTrim("parameter"));
                    }
                }
            }
            
            String tp = "";
            org.dom4j.Element uripartsel = lConf.element("uriparts");
            if (uripartsel!=null) {
                java.util.List<org.dom4j.Element> temp = uripartsel.elements("part");
                for (org.dom4j.Element part : temp) {
                    if (part.attributeValue("static")!=null && part.attributeValue("static").equals("1")) {
                        tp += part.elementTextTrim("value")+Functions.getSeparator(part);
                    } else if (translatedpagepath.get(part.elementTextTrim("parameter"))!=null && paramsinorder.get(part.elementTextTrim("parameter"))==null) {
                        tp += translatedpagepath.get(part.elementTextTrim("parameter"))+Functions.getSeparator(part);
                        params.remove(part.elementTextTrim("parameter"));
                    }
                }
            }
            
            // if pagepath is not empty, that means not all pagepaths were added to $translatepagepath. We'll just add it
            String pagep = "";
            //org.dom4j.Element pagepathel = lConf.element("pagepath"); // aleady defined
            if (pagepathel!=null && pagepathel.element("saveto")!=null && !pagepath.isEmpty()) {
                pagep = Functions.implode(Functions.getSeparator(),pagepath)+Functions.getSeparator();
            }
            
            org.dom4j.Element partorderel = lConf.element("partorder");
            java.util.List<String> partorder = new java.util.LinkedList<String>();
            if (partorderel!=null && partorderel.element("part")!=null) {
                java.util.List<org.dom4j.Element> parts = partorderel.elements("part");
                for (org.dom4j.Element part : parts) {
                    partorder.add(part.getTextTrim());
                }
            } else {
                partorder.add("pagepath");
                partorder.add("uriparts");
                partorder.add("valuemaps");
                partorder.add("predefinedparts");
            }
            
            for (String p : partorder) {
                if (p.equals("pagepath")) path += pagep;
                else if (p.equals("valuemaps")) path += vm;
                else if (p.equals("predefinedparts")) path += pp;
                else if (p.equals("uriparts")) path += tp;
            }
            
            String paramss = "";
            if (!params.isEmpty()) {
                paramss = "?"+Functions.convertArrayToQuerystring(params,entityampersand?"&amp;":"&");
            }
            
            // if cache is allowed, we'll save path to the cache (excluding possible prefix and suffix)
            if (cache!=null && cache.element("usecache")!=null && cache.elementTextTrim("usecache").equals("1")) {
                String tap = Functions.getTablesPrefix(cache);
                java.sql.Statement db = DB.getInstance();
                
                String p;
                if (cache.element("cacheparams")!=null && cache.elementTextTrim("cacheparams").equals("1") && !params.isEmpty()) {
                    p = paramss;
                } else {
                    p = "";
                }
                
                if (!originalparams.isEmpty()) {
                    if (updatecacheid!=0) {
                        // first we will update the timestamp (so we will now, when the last uri check was)
                        db.executeUpdate("UPDATE "+tap+"cache SET tstamp=NOW() WHERE id="+updatecacheid);
                        if (!cacheduri.equals(path+p)) {
                            // uri is changed, we need to move the old one to the old links
                            db.executeUpdate("INSERT INTO "+tap+"oldlinks(link_id,url) VALUES("+updatecacheid+",'"+cacheduri+"')");
                            db.executeUpdate("UPDATE "+tap+"cache SET url='"+path+p+"' WHERE id="+updatecacheid);

                            // if the path has changed back, no need to store it in the oldlinks
                            // prevets from overflooding the DB when tampering with configuration
                            db.executeUpdate("DELETE FROM "+tap+"oldlinks WHERE url='"+path+p+"'");
                        }
                    } else {
                        java.sql.ResultSet res = db.executeQuery("SELECT * FROM "+tap+"cache WHERE url='"+path+p+"'");
                        if (!res.last()) {
                            db.executeUpdate("INSERT INTO "+tap+"cache(url,params,crdatetime) VALUES('"+path+p+"','"+Functions.prepareParamsForCache(originalparams)+"',NOW())");
                        }
                    }
                }
            }
            
            
            return Functions.prepareforOutput(path+paramss,lConf);
        } else { // end cooluris covertion
            return file+(params.isEmpty()?"":"?"+Functions.convertArrayToQuerystring(params,entityampersand?"&amp;":"&"));
        }
    }
    
    /**
     * Returns all parameters
     * @return Map of parameters
     */
    public java.util.HashMap<String,String> GETall() {
        return this.parameters;
    }
    
    /**
     * Returns single parameter
     * @param var Param name
     * @return Param value or null if param doesn't exist
     */
    public String GET(String var) {
        return this.parameters.get(var);
    }
    
}
